Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 2318)
+++ inc/core/class.dc.blog.php	(revision 2521)
@@ -1529,9 +1529,9 @@
 			$strReq .= "AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
 		}
-		
+
 		$this->con->execute($strReq);
 		$this->triggerBlog();
 	}
-	
+
 	/**
 	Publishes all entries flaged as "scheduled".
@@ -1543,7 +1543,7 @@
 				'WHERE post_status = -1 '.
 				"AND blog_id = '".$this->con->escape($this->id)."' ";
-		
+
 		$rs = $this->con->select($strReq);
-		
+
 		$now = dt::toUTC(time());
 		$to_change = new ArrayObject();
@@ -1552,13 +1552,13 @@
 			return;
 		}
-		
+
 		while ($rs->fetch())
 		{
 			# Now timestamp with post timezone
 			$now_tz = $now + dt::getTimeOffset($rs->post_tz,$now);
-			
+
 			# Post timestamp
 			$post_ts = strtotime($rs->post_dt);
-			
+
 			# If now_tz >= post_ts, we publish the entry
 			if ($now_tz >= $post_ts) {
@@ -1582,10 +1582,10 @@
 			$this->core->callBehavior('coreAfterScheduledEntriesPublish',$this,$to_change);
 		}
-		
-	}
-	
+
+	}
+
 	/**
 	Retrieves all users having posts on current blog.
-	
+
 	@param	post_type		<b>string</b>		post_type filter (post)
 	@return	record
@@ -1598,22 +1598,22 @@
 				'WHERE P.user_id = U.user_id '.
 				"AND blog_id = '".$this->con->escape($this->id)."' ";
-		
+
 		if ($post_type) {
 			$strReq .= "AND post_type = '".$this->con->escape($post_type)."' ";
 		}
-		
+
 		$strReq .= 'GROUP BY P.user_id, user_name, user_firstname, user_displayname, user_email ';
-		
+
 		return $this->con->select($strReq);
 	}
-	
+
 	private function getPostsCategoryFilter($arr,$field='cat_id')
 	{
 		$field = $field == 'cat_id' ? 'cat_id' : 'cat_url';
-		
+
 		$sub = array();
 		$not = array();
 		$queries = array();
-		
+
 		foreach ($arr as $v)
 		{
@@ -1622,5 +1622,5 @@
 			$id = array_shift($args);
 			$args = array_flip($args);
-			
+
 			if (isset($args['not'])) { $not[$id] = 1; }
 			if (isset($args['sub'])) { $sub[$id] = 1; }
@@ -1636,5 +1636,5 @@
 			}
 		}
-		
+
 		if (!empty($sub)) {
 			$rs = $this->con->select(
@@ -1643,10 +1643,10 @@
 				'AND '.$field.' '.$this->con->in(array_keys($sub))
 			);
-			
+
 			while ($rs->fetch()) {
 				$queries[$rs->f($field)] = '(C.cat_lft BETWEEN '.$rs->cat_lft.' AND '.$rs->cat_rgt.')';
 			}
 		}
-		
+
 		# Create queries
 		$sql = array(
@@ -1654,12 +1654,12 @@
 			1 => array()  # excluded categories
 		);
-		
+
 		foreach ($queries as $id => $q) {
 			$sql[(integer) isset($not[$id])][] = $q;
 		}
-		
+
 		$sql[0] = implode(' OR ',$sql[0]);
 		$sql[1] = implode(' OR ',$sql[1]);
-		
+
 		if ($sql[0]) {
 			$sql[0] = '('.$sql[0].')';
@@ -1667,5 +1667,5 @@
 			unset($sql[0]);
 		}
-		
+
 		if ($sql[1]) {
 			$sql[1] = '(P.cat_id IS NULL OR NOT('.$sql[1].'))';
@@ -1673,8 +1673,8 @@
 			unset($sql[1]);
 		}
-		
+
 		return implode(' AND ',$sql);
 	}
-	
+
 	private function getPostCursor($cur,$post_id=null)
 	{
@@ -1682,13 +1682,13 @@
 			throw new Exception(__('No entry title'));
 		}
-		
+
 		if ($cur->post_content == '') {
 			throw new Exception(__('No entry content'));
 		}
-		
+
 		if ($cur->post_password === '') {
 			$cur->post_password = null;
 		}
-		
+
 		if ($cur->post_dt == '') {
 			$offset = dt::getTimeOffset($this->core->auth->getInfo('user_tz'));
@@ -1696,11 +1696,11 @@
 			$cur->post_dt = date('Y-m-d H:i:00',$now);
 		}
-		
+
 		$post_id = is_int($post_id) ? $post_id : $cur->post_id;
-		
+
 		if ($cur->post_content_xhtml == '') {
 			throw new Exception(__('No entry content'));
 		}
-		
+
 		# Words list
 		if ($cur->post_title !== null && $cur->post_excerpt_xhtml !== null
@@ -1711,9 +1711,9 @@
 			$cur->post_excerpt_xhtml.' '.
 			$cur->post_content_xhtml;
-			
+
 			$cur->post_words = implode(' ',text::splitWords($words));
 		}
 	}
-	
+
 	private function getPostContent($cur,$post_id)
 	{
@@ -1722,5 +1722,5 @@
 		$post_content = $cur->post_content;
 		$post_content_xhtml = $cur->post_content_xhtml;
-		
+
 		$this->setPostContent(
 			$post_id,$cur->post_format,$cur->post_lang,
@@ -1728,5 +1728,5 @@
 			$post_content,$post_content_xhtml
 		);
-		
+
 		$cur->post_excerpt = $post_excerpt;
 		$cur->post_excerpt_xhtml = $post_excerpt_xhtml;
@@ -1734,8 +1734,8 @@
 		$cur->post_content_xhtml = $post_content_xhtml;
 	}
-	
+
 	/**
 	Creates post HTML content, taking format and lang into account.
-	
+
 	@param		post_id		<b>integer</b>		Post ID
 	@param		format		<b>string</b>		Post format
@@ -1771,5 +1771,5 @@
 			}
 		}
-		
+
 		if ($excerpt) {
 			$excerpt_xhtml = $this->core->callFormater($format,$excerpt);
@@ -1778,5 +1778,5 @@
 			$excerpt_xhtml = '';
 		}
-		
+
 		if ($content) {
 			$content_xhtml = $this->core->callFormater($format,$content);
@@ -1785,5 +1785,5 @@
 			$content_xhtml = '';
 		}
-		
+
 		# --BEHAVIOR-- coreAfterPostContentFormat
 		$this->core->callBehavior('coreAfterPostContentFormat',array(
@@ -1794,9 +1794,9 @@
 		));
 	}
-	
+
 	/**
 	Returns URL for a post according to blog setting <var>post_url_format</var>.
 	It will try to guess URL and append some figures if needed.
-	
+
 	@param	url			<b>string</b>		Origin URL, could be empty
 	@param	post_dt		<b>string</b>		Post date (in YYYY-MM-DD HH:mm:ss)
@@ -1808,5 +1808,5 @@
 	{
 		$url = trim($url);
-		
+
 		$url_patterns = array(
 		'{y}' => date('Y',strtotime($post_dt)),
@@ -1816,5 +1816,5 @@
 		'{id}' => (integer) $post_id
 		);
-		
+
 		# If URL is empty, we create a new one
 		if ($url == '')
@@ -1831,5 +1831,5 @@
 			$url = text::tidyURL($url);
 		}
-		
+
 		# Let's check if URL is taken...
 		$strReq = 'SELECT post_url FROM '.$this->prefix.'post '.
@@ -1838,7 +1838,7 @@
 				"AND blog_id = '".$this->con->escape($this->id)."' ".
 				'ORDER BY post_url DESC';
-		
+
 		$rs = $this->con->select($strReq);
-		
+
 		if (!$rs->isEmpty())
 		{
@@ -1855,5 +1855,5 @@
 					"AND blog_id = '".$this->con->escape($this->id)."' ".
 					'ORDER BY post_url DESC ';
-			
+
 			$rs = $this->con->select($strReq);
 			$a = array();
@@ -1861,8 +1861,8 @@
 				$a[] = $rs->post_url;
 			}
-			
+
 			natsort($a);
 			$t_url = end($a);
-			
+
 			if (preg_match('/(.*?)([0-9]+)$/',$t_url,$m)) {
 				$i = (integer) $m[2];
@@ -1871,17 +1871,17 @@
 				$i = 1;
 			}
-			
+
 			return $url.($i+1);
 		}
-		
+
 		# URL is empty?
 		if ($url == '') {
 			throw new Exception(__('Empty entry URL'));
 		}
-		
+
 		return $url;
 	}
 	//@}
-	
+
 	/// @name Comments management methods
 	//@{
@@ -1889,10 +1889,10 @@
 	Retrieves comments. <b>$params</b> is an array taking the following
 	optionnal parameters:
-	
+
 	- no_content: Don't retrieve comment content
-	- post_type: Get only entries with given type (default no type, array for many types) 
+	- post_type: Get only entries with given type (default no type, array for many types)
 	- post_id: (integer) Get comments belonging to given post_id
 	- cat_id: (integer or array) Get comments belonging to entries of given category ID
-	- comment_id: (integer) Get comment with given ID
+	- comment_id: (integer or array) Get comment with given ID (or IDs)
 	- comment_site: (string) Get comments with given comment_site
 	- comment_status: (integer) Get comments with given comment_status
@@ -1907,5 +1907,5 @@
 	- limit: Limit parameter
 	- sql_only : return the sql request instead of results. Only ids are selected
-	
+
 	@param	params		<b>array</b>		Parameters
 	@param	count_only	<b>boolean</b>		Only counts results
@@ -1918,5 +1918,5 @@
 			$strReq = 'SELECT count(comment_id) ';
 		}
-		elseif (!empty($params['sql_only'])) 
+		elseif (!empty($params['sql_only']))
 		{
 			$strReq = 'SELECT P.post_id ';
@@ -1929,9 +1929,9 @@
 				$content_req = 'comment_content, ';
 			}
-			
+
 			if (!empty($params['columns']) && is_array($params['columns'])) {
 				$content_req .= implode(', ',$params['columns']).', ';
 			}
-			
+
 			$strReq =
 			'SELECT C.comment_id, comment_dt, comment_tz, comment_upddt, '.
@@ -1942,25 +1942,25 @@
 			'P.post_dt, P.user_id, U.user_email, U.user_url ';
 		}
-		
+
 		$strReq .=
 		'FROM '.$this->prefix.'comment C '.
 		'INNER JOIN '.$this->prefix.'post P ON C.post_id = P.post_id '.
 		'INNER JOIN '.$this->prefix.'user U ON P.user_id = U.user_id ';
-		
+
 		if (!empty($params['from'])) {
 			$strReq .= $params['from'].' ';
 		}
-		
+
 		$strReq .=
 		"WHERE P.blog_id = '".$this->con->escape($this->id)."' ";
-		
+
 		if (!$this->core->auth->check('contentadmin',$this->id)) {
 			$strReq .= 'AND ((comment_status = 1 AND P.post_status = 1 ';
-			
+
 			if ($this->without_password) {
 				$strReq .= 'AND post_password IS NULL ';
 			}
 			$strReq .= ') ';
-			
+
 			if ($this->core->auth->userID()) {
 				$strReq .= "OR P.user_id = '".$this->con->escape($this->core->auth->userID())."')";
@@ -1969,54 +1969,59 @@
 			}
 		}
-		
+
 		if (!empty($params['post_type']))
 		{
 			$strReq .= 'AND post_type '.$this->con->in($params['post_type']);
 		}
-		
+
 		if (isset($params['post_id']) && $params['post_id'] !== '') {
 			$strReq .= 'AND P.post_id = '.(integer) $params['post_id'].' ';
 		}
-		
+
 		if (isset($params['cat_id']) && $params['cat_id'] !== '') {
 			$strReq .= 'AND P.cat_id = '.(integer) $params['cat_id'].' ';
 		}
-		
+
 		if (isset($params['comment_id']) && $params['comment_id'] !== '') {
-			$strReq .= 'AND comment_id = '.(integer) $params['comment_id'].' ';
-		}
-		
+			if (is_array($params['comment_id'])) {
+				array_walk($params['comment_id'],create_function('&$v,$k','if($v!==null){$v=(integer)$v;}'));
+			} else {
+				$params['comment_id'] = array((integer) $params['comment_id']);
+			}
+			$strReq .= 'AND comment_id '.$this->con->in($params['comment_id']);
+		}
+
 		if (isset($params['comment_site'])) {
 			$comment_site = $this->con->escape(str_replace('*','%',$params['comment_site']));
 			$strReq .= "AND comment_site LIKE '".$comment_site."' ";
 		}
-		
+
 		if (isset($params['comment_status'])) {
 			$strReq .= 'AND comment_status = '.(integer) $params['comment_status'].' ';
 		}
-		
+
 		if (!empty($params['comment_status_not']))
 		{
 			$strReq .= 'AND comment_status <> '.(integer) $params['comment_status_not'].' ';
 		}
-		
+
 		if (isset($params['comment_trackback'])) {
 			$strReq .= 'AND comment_trackback = '.(integer) (boolean) $params['comment_trackback'].' ';
 		}
-		
+
 		if (isset($params['comment_ip'])) {
 			$comment_ip = $this->con->escape(str_replace('*','%',$params['comment_ip']));
 			$strReq .= "AND comment_ip LIKE '".$comment_ip."' ";
 		}
-		
+
 		if (isset($params['q_author'])) {
 			$q_author = $this->con->escape(str_replace('*','%',strtolower($params['q_author'])));
 			$strReq .= "AND LOWER(comment_author) LIKE '".$q_author."' ";
 		}
-		
+
 		if (!empty($params['search']))
 		{
 			$words = text::splitWords($params['search']);
-			
+
 			if (!empty($words))
 			{
@@ -2025,5 +2030,5 @@
 					$this->core->callBehavior('coreCommentSearch',$this->core,array(&$words,&$strReq,&$params));
 				}
-				
+
 				if ($words)
 				{
@@ -2035,9 +2040,9 @@
 			}
 		}
-		
+
 		if (!empty($params['sql'])) {
 			$strReq .= $params['sql'].' ';
 		}
-		
+
 		if (!$count_only)
 		{
@@ -2048,5 +2053,5 @@
 			}
 		}
-		
+
 		if (!$count_only && !empty($params['limit'])) {
 			$strReq .= $this->con->limit($params['limit']);
@@ -2056,19 +2061,19 @@
 			return $strReq;
 		}
-		
+
 		$rs = $this->con->select($strReq);
 		$rs->core = $this->core;
 		$rs->extend('rsExtComment');
-		
+
 		# --BEHAVIOR-- coreBlogGetComments
 		$this->core->callBehavior('coreBlogGetComments',$rs);
-		
+
 		return $rs;
 	}
-	
+
 	/**
 	Creates a new comment. Takes a cursor as input and returns the new comment
 	ID.
-	
+
 	@param	cur		<b>cursor</b>		Comment cursor
 	@return	<b>integer</b>		New comment ID
@@ -2082,23 +2087,23 @@
 			$rs = $this->con->select(
 				'SELECT MAX(comment_id) '.
-				'FROM '.$this->prefix.'comment ' 
+				'FROM '.$this->prefix.'comment '
 			);
-			
+
 			$cur->comment_id = (integer) $rs->f(0) + 1;
 			$cur->comment_upddt = date('Y-m-d H:i:s');
-			
+
 			$offset = dt::getTimeOffset($this->settings->system->blog_timezone);
 			$cur->comment_dt = date('Y-m-d H:i:s',time() + $offset);
 			$cur->comment_tz = $this->settings->system->blog_timezone;
-			
+
 			$this->getCommentCursor($cur);
-			
+
 			if ($cur->comment_ip === null) {
 				$cur->comment_ip = http::realIP();
 			}
-			
+
 			# --BEHAVIOR-- coreBeforeCommentCreate
 			$this->core->callBehavior('coreBeforeCommentCreate',$this,$cur);
-			
+
 			$cur->insert();
 			$this->con->unlock();
@@ -2109,18 +2114,18 @@
 			throw $e;
 		}
-		
+
 		# --BEHAVIOR-- coreAfterCommentCreate
 		$this->core->callBehavior('coreAfterCommentCreate',$this,$cur);
-		
+
 		$this->triggerComment($cur->comment_id);
 		if ($cur->comment_status != -2) {
 			$this->triggerBlog();
-		}	
+		}
 		return $cur->comment_id;
 	}
-	
+
 	/**
 	Updates an existing comment.
-	
+
 	@param	id		<b>integer</b>		Comment ID
 	@param	cur		<b>cursor</b>		Comment cursor
@@ -2131,17 +2136,17 @@
 			throw new Exception(__('You are not allowed to update comments'));
 		}
-		
+
 		$id = (integer) $id;
-		
+
 		if (empty($id)) {
 			throw new Exception(__('No such comment ID'));
 		}
-		
+
 		$rs = $this->getComments(array('comment_id' => $id));
-		
+
 		if ($rs->isEmpty()) {
 			throw new Exception(__('No such comment ID'));
 		}
-		
+
 		#If user is only usage, we need to check the post's owner
 		if (!$this->core->auth->check('contentadmin',$this->id))
@@ -2151,28 +2156,28 @@
 			}
 		}
-		
+
 		$this->getCommentCursor($cur);
-		
+
 		$cur->comment_upddt = date('Y-m-d H:i:s');
-		
+
 		if (!$this->core->auth->check('publish,contentadmin',$this->id)) {
 			$cur->unsetField('comment_status');
 		}
-		
+
 		# --BEHAVIOR-- coreBeforeCommentUpdate
 		$this->core->callBehavior('coreBeforeCommentUpdate',$this,$cur,$rs);
-		
+
 		$cur->update('WHERE comment_id = '.$id.' ');
-		
+
 		# --BEHAVIOR-- coreAfterCommentUpdate
 		$this->core->callBehavior('coreAfterCommentUpdate',$this,$cur,$rs);
-		
+
 		$this->triggerComment($id);
 		$this->triggerBlog();
 	}
-	
+
 	/**
 	Updates comment status.
-	
+
 	@param	id		<b>integer</b>		Comment ID
 	@param	status	<b>integer</b>		Comment status
@@ -2182,8 +2187,8 @@
 		$this->updCommentsStatus($id,$status);
 	}
-	
+
 	/**
 	Updates comments status.
-	
+
 	@param	ids		<b>mixed</b>		Comment(s) ID(s)
 	@param	status	<b>integer</b>		Comment status
@@ -2194,51 +2199,51 @@
 			throw new Exception(__("You are not allowed to change this comment's status"));
 		}
-		
+
 		$co_ids = dcUtils::cleanIds($ids);
 		$status = (integer) $status;
-		
-		$strReq = 
+
+		$strReq =
 			'UPDATE '.$this->prefix.'comment tc ';
-		
+
 		# mySQL uses "JOIN" synthax
 		if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
-			$strReq .= 
+			$strReq .=
 				'JOIN '.$this->prefix.'post tp ON tc.post_id = tp.post_id ';
 		}
-		
-		$strReq .= 
+
+		$strReq .=
 			'SET comment_status = '.$status.' ';
-		
+
 		# pgSQL uses "FROM" synthax
 		if ($this->con->driver() != 'mysql' && $this->con->driver() != 'mysqli') {
-			$strReq .= 
+			$strReq .=
 				'FROM '.$this->prefix.'post tp ';
 		}
-		
+
 		$strReq .=
 			"WHERE blog_id = '".$this->con->escape($this->id)."' ".
 			'AND comment_id'.$this->con->in($co_ids);
-		
+
 		# add pgSQL "WHERE" clause
 		if ($this->con->driver() != 'mysql' && $this->con->driver() != 'mysqli') {
-			$strReq .= 
+			$strReq .=
 				'AND tc.post_id = tp.post_id ';
 		}
-		
+
 		#If user is only usage, we need to check the post's owner
 		if (!$this->core->auth->check('contentadmin',$this->id))
 		{
-			$strReq .= 
+			$strReq .=
 				"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
 		}
-		
+
 		$this->con->execute($strReq);
 		$this->triggerComments($co_ids);
 		$this->triggerBlog();
 	}
-	
+
 	/**
 	Delete a comment
-	
+
 	@param	id		<b>integer</b>		Comment ID
 	*/
@@ -2247,8 +2252,8 @@
 		$this->delComments($id);
 	}
-	
+
 	/**
 	Delete comments
-	
+
 	@param	ids		<b>mixed</b>		Comment(s) ID(s)
 	*/
@@ -2258,11 +2263,11 @@
 			throw new Exception(__('You are not allowed to delete comments'));
 		}
-		
+
 		$co_ids = dcUtils::cleanIds($ids);
-		
+
 		if (empty($co_ids)) {
 			throw new Exception(__('No such comment ID'));
 		}
-		
+
 		# Retrieve posts affected by comments edition
 		$affected_posts = array();
@@ -2272,14 +2277,14 @@
 			'WHERE comment_id'.$this->con->in($co_ids).
 			'GROUP BY post_id';
-		
+
 		$rs = $this->con->select($strReq);
-		
+
 		while ($rs->fetch()) {
 			$affected_posts[] = (integer) $rs->post_id;
 		}
-		
+
 		# mySQL uses "INNER JOIN" synthax
 		if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
-			$strReq = 
+			$strReq =
 				'DELETE FROM tc '.
 				'USING '.$this->prefix.'comment tc '.
@@ -2288,21 +2293,21 @@
 		# pgSQL uses nothing special
 		else {
-			$strReq = 
+			$strReq =
 				'DELETE FROM '.$this->prefix.'comment tc '.
 				'USING '.$this->prefix.'post tp ';
 		}
-		
-		$strReq .= 
+
+		$strReq .=
 			'WHERE tc.post_id = tp.post_id '.
 			"AND tp.blog_id = '".$this->con->escape($this->id)."' ".
 			'AND comment_id'.$this->con->in($co_ids);
-		
+
 		#If user can only delete, we need to check the post's owner
 		if (!$this->core->auth->check('contentadmin',$this->id))
 		{
-			$strReq .= 
+			$strReq .=
 				"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
 		}
-		
+
 		$this->con->execute($strReq);
 		$this->triggerComments($co_ids, true, $affected_posts);
@@ -2315,8 +2320,8 @@
 			throw new Exception(__('You are not allowed to delete comments'));
 		}
-		
+
 		# mySQL uses "INNER JOIN" synthax
 		if ($this->con->driver() == 'mysql' || $this->con->driver() == 'mysqli') {
-			$strReq = 
+			$strReq =
 				'DELETE FROM tc '.
 				'USING '.$this->prefix.'comment tc '.
@@ -2325,25 +2330,25 @@
 		# pgSQL uses nothing special
 		else {
-			$strReq = 
+			$strReq =
 				'DELETE FROM '.$this->prefix.'comment tc '.
 				'USING '.$this->prefix.'post tp ';
 		}
-		
-		$strReq .= 
+
+		$strReq .=
 			'WHERE tc.post_id = tp.post_id '.
 			"AND tp.blog_id = '".$this->con->escape($this->id)."' ".
 			'AND comment_status = -2';
-		
+
 		#If user can only delete, we need to check the post's owner
 		if (!$this->core->auth->check('contentadmin',$this->id))
 		{
-			$strReq .= 
+			$strReq .=
 				"AND user_id = '".$this->con->escape($this->core->auth->userID())."' ";
 		}
-		
+
 		$this->con->execute($strReq);
 		$this->triggerBlog();
 	}
-	
+
 	private function getCommentCursor($cur)
 	{
@@ -2351,13 +2356,13 @@
 			throw new Exception(__('You must provide a comment'));
 		}
-		
+
 		if ($cur->comment_author !== null && $cur->comment_author == '') {
 			throw new Exception(__('You must provide an author name'));
 		}
-		
+
 		if ($cur->comment_email != '' && !text::isEmail($cur->comment_email)) {
 			throw new Exception(__('Email address is not valid.'));
 		}
-		
+
 		if ($cur->comment_site !== null && $cur->comment_site != '') {
 			if (!preg_match('|^http(s?)://|i',$cur->comment_site, $matches)) {
@@ -2367,9 +2372,9 @@
 			}
 		}
-		
+
 		if ($cur->comment_status === null) {
 			$cur->comment_status = (integer) $this->settings->system->comments_pub;
 		}
-		
+
 		# Words list
 		if ($cur->comment_content !== null)
Index: inc/core/class.dc.namespace.php
===================================================================
--- inc/core/class.dc.namespace.php	(revision 1179)
+++ inc/core/class.dc.namespace.php	(revision 2505)
@@ -22,14 +22,14 @@
 	protected $table;		///< <b>string</b> Settings table name
 	protected $blog_id;		///< <b>string</b> Blog ID
-	
+
 	protected $global_settings = array();	///< <b>array</b> Global settings array
 	protected $local_settings = array();	///< <b>array</b> Local settings array
 	protected $settings = array();		///< <b>array</b> Associative settings array
 	protected $ns;			///< <b>string</b> Current namespace
-	
+
 	/**
 	Object constructor. Retrieves blog settings and puts them in $settings
 	array. Local (blog) settings have a highest priority than global settings.
-	
+
 	@param	name		<b>string</b>		ID for this namespace
 	*/
@@ -41,14 +41,14 @@
 			throw new Exception(sprintf(__('Invalid setting dcNamespace: %s'),$name));
 		}
-		
+
 		$this->con =& $core->con;
 		$this->table = $core->prefix.'setting';
 		$this->blog_id =& $blog_id;
-		
+
 		$this->getSettings($rs);
 	}
-	
+
 	private function getSettings($rs=null)
-	{	
+	{
 		if ($rs == null) {
 			$strReq = 'SELECT blog_id, setting_id, setting_value, '.
@@ -59,5 +59,5 @@
 					"AND setting_ns = '".$this->con->escape($this->ns)."' ".
 					'ORDER BY setting_id DESC ';
-		
+
 			try {
 				$rs = $this->con->select($strReq);
@@ -74,5 +74,5 @@
 			$value = $rs->f('setting_value');
 			$type = $rs->f('setting_type');
-			
+
 			if ($type == 'float' || $type == 'double') {
 				$type = 'float';
@@ -80,9 +80,9 @@
 				$type = 'string';
 			}
-			
+
 			settype($value,$type);
-			
+
 			$array = $rs->blog_id ? 'local' : 'global';
-			
+
 			$this->{$array.'_settings'}[$id] = array(
 				'ns' => $this->ns,
@@ -93,14 +93,14 @@
 			);
 		}
-		
+
 		$this->settings = $this->global_settings;
-		
+
 		foreach ($this->local_settings as $id => $v) {
 			$this->settings[$id] = $v;
 		}
-		
+
 		return true;
 	}
-	
+
 	private function settingExists($id,$global=false)
 	{
@@ -108,8 +108,8 @@
 		return isset($this->{$array.'_settings'}[$id]);
 	}
-	
+
 	/**
 	Returns setting value if exists.
-	
+
 	@param	n		<b>string</b>		Setting name
 	@return	<b>mixed</b>
@@ -120,8 +120,38 @@
 			return $this->settings[$n]['value'];
 		}
-		
+
 		return null;
 	}
-	
+
+	/**
+	Returns global setting value if exists.
+
+	@param	n		<b>string</b>		setting name
+	@return	<b>mixed</b>
+	*/
+	public function getGlobal($n)
+	{
+		if (isset($this->global_settings[$n]['value'])) {
+			return $this->global_settings[$n]['value'];
+		}
+
+		return null;
+	}
+
+	/**
+	Returns local setting value if exists.
+
+	@param	n		<b>string</b>		setting name
+	@return	<b>mixed</b>
+	*/
+	public function getLocal($n)
+	{
+		if (isset($this->local_settings[$n]['value'])) {
+			return $this->local_settings[$n]['value'];
+		}
+
+		return null;
+	}
+
 	/**
 	Magic __get method.
@@ -132,9 +162,9 @@
 		return $this->get($n);
 	}
-	
+
 	/**
 	Sets a setting in $settings property. This sets the setting for script
 	execution time only and if setting exists.
-	
+
 	@param	n		<b>string</b>		Setting name
 	@param	v		<b>mixed</b>		Setting value
@@ -146,5 +176,5 @@
 		}
 	}
-	
+
 	/**
 	Magic __set method.
@@ -155,14 +185,14 @@
 		$this->set($n,$v);
 	}
-	
+
 	/**
 	Creates or updates a setting.
-	
+
 	$type could be 'string', 'integer', 'float', 'boolean' or null. If $type is
 	null and setting exists, it will keep current setting type.
-	
+
 	$value_change allow you to not change setting. Useful if you need to change
 	a setting label or type and don't want to change its value.
-	
+
 	@param	id			<b>string</b>		Setting ID
 	@param	value		<b>mixed</b>		Setting value
@@ -177,5 +207,5 @@
 			throw new Exception(sprintf(__('%s is not a valid setting id'),$id));
 		}
-		
+
 		# We don't want to change setting value
 		if (!$value_change)
@@ -187,5 +217,5 @@
 			}
 		}
-		
+
 		# Setting type
 		if ($type == 'double')
@@ -207,5 +237,5 @@
 			$type = 'string';
 		}
-		
+
 		# We don't change label
 		if ($label == null)
@@ -217,12 +247,12 @@
 			}
 		}
-		
+
 		settype($value,$type);
-		
+
 		$cur = $this->con->openCursor($this->table);
 		$cur->setting_value = ($type == 'boolean') ? (string) (integer) $value : (string) $value;
 		$cur->setting_type = $type;
 		$cur->setting_label = $label;
-		
+
 		#If we are local, compare to global value
 		if (!$global && $this->settingExists($id,true))
@@ -231,5 +261,5 @@
 			$same_setting = $g['ns'] == $this->ns && $g['value'] == $value
 			&& $g['type'] == $type && $g['label'] == $label;
-			
+
 			# Drop setting if same value as global
 			if ($same_setting && $this->settingExists($id,false)) {
@@ -239,5 +269,5 @@
 			}
 		}
-		
+
 		if ($this->settingExists($id,$global) && $this->ns == $this->settings[$id]['ns'])
 		{
@@ -247,5 +277,5 @@
 				$where = "WHERE blog_id = '".$this->con->escape($this->blog_id)."' ";
 			}
-			
+
 			$cur->update($where."AND setting_id = '".$this->con->escape($id)."' AND setting_ns = '".$this->con->escape($this->ns)."' ");
 		}
@@ -255,5 +285,5 @@
 			$cur->blog_id = $global ? null : $this->blog_id;
 			$cur->setting_ns = $this->ns;
-			
+
 			$cur->insert();
 		}
@@ -272,5 +302,5 @@
 			throw new Exception(__('No namespace specified'));
 		}
-		
+
 		if (!array_key_exists($oldId,$this->settings) || array_key_exists($newId,$this->settings)) {
 			return false;
@@ -291,6 +321,6 @@
 
 	/**
-	Removes an existing setting in a Namespace 
-	
+	Removes an existing setting in a Namespace
+
 	@param	id		<b>string</b>		Setting ID
 	*/
@@ -300,7 +330,7 @@
 			throw new Exception(__('No namespace specified'));
 		}
-		
+
 		$strReq =	'DELETE FROM '.$this->table.' ';
-		
+
 		if ($this->blog_id === null) {
 			$strReq .= 'WHERE blog_id IS NULL ';
@@ -308,14 +338,14 @@
 			$strReq .= "WHERE blog_id = '".$this->con->escape($this->blog_id)."' ";
 		}
-		
+
 		$strReq .= "AND setting_id = '".$this->con->escape($id)."' ";
 		$strReq .= "AND setting_ns = '".$this->con->escape($this->ns)."' ";
-		
+
 		$this->con->execute($strReq);
 	}
-	
-	/**
-	Removes all existing settings in a Namespace 
-	
+
+	/**
+	Removes all existing settings in a Namespace
+
 	@param	force_global	<b>boolean</b>	Force global pref drop
 	*/
@@ -325,7 +355,7 @@
 			throw new Exception(__('No namespace specified'));
 		}
-		
+
 		$strReq =	'DELETE FROM '.$this->table.' ';
-		
+
 		if (($force_global) || ($this->blog_id === null)) {
 			$strReq .= 'WHERE blog_id IS NULL ';
@@ -335,20 +365,20 @@
 			$global = false;
 		}
-		
+
 		$strReq .= "AND setting_ns = '".$this->con->escape($this->ns)."' ";
-		
+
 		$this->con->execute($strReq);
-		
+
 		$array = $global ? 'global' : 'local';
 		unset($this->{$array.'_settings'});
 		$this->{$array.'_settings'} = array();
-		
+
 		$array = $global ? 'local' : 'global';
 		$this->settings = $this->{$array.'_settings'};
 	}
-	
+
 	/**
 	Returns $settings property content.
-	
+
 	@return	<b>array</b>
 	*/
@@ -357,8 +387,8 @@
 		return $this->settings;
 	}
-	
+
 	/**
 	Returns $global_settings property content.
-	
+
 	@return	<b>array</b>
 	*/
Index: inc/core/class.dc.themes.php
===================================================================
--- inc/core/class.dc.themes.php	(revision 2492)
+++ inc/core/class.dc.themes.php	(revision 2541)
@@ -22,5 +22,5 @@
 */
 class dcThemes extends dcModules
-{	
+{
 	protected static $type = 'theme';
 
@@ -28,18 +28,18 @@
 	This method registers a theme in modules list. You should use this to
 	register a new theme.
-	
+
 	<var>$parent</var> is a optional value to indicate them inheritance.
-	If <var>$parent</var> is null / not set, we simply fall back to 
+	If <var>$parent</var> is null / not set, we simply fall back to
 	the standard behavior, by using 'default'.
-	
+
 	<var>$priority</var> is an integer. Modules are sorted by priority and name.
 	Lowest priority comes first. This property is currently ignored when dealing
 	with themes.
-	
+
 	@param	name			<b>string</b>		Module name
 	@param	desc			<b>string</b>		Module description
 	@param	author		<b>string</b>		Module author name
 	@param	version		<b>string</b>		Module version
-	@param	properties	<b>array</b>		extra properties 
+	@param	properties	<b>array</b>		extra properties
 	(currently available keys : parent, priority, standalone_config, type)
 	*/
@@ -59,5 +59,5 @@
 		# Themes specifics properties
 		$properties = array_merge(
-			array('parent' => null),
+			array('parent' => null, 'tplset' => 'legacy'),
 			$properties,
 			array('permissions' => 'admin') // force themes perms
@@ -65,11 +65,11 @@
 
 		parent::registerModule($name, $desc, $author, $version, $properties);
-	}	
-	
+	}
+
 	/**
 	Loads namespace <var>$ns</var> specific file for module with ID
 	<var>$id</var>
 	Note : actually, only 'public' namespace is supported with themes.
-	
+
 	@param	id		<b>string</b>		Module ID
 	@param	ns		<b>string</b>		Namespace name
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 2555)
+++ inc/prepend.php	(revision 2557)
@@ -135,5 +135,5 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.6.1');
+define('DC_VERSION','2.7-dev');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
